﻿'Benötigte Importanweisungen...
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.Threading

Public Class Form1
    'Zur Kommunikation benötigte Funktionen
    Public CNC As New CNC_Remote

    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = &H400 Then CNC.Receive(m) Else MyBase.WndProc(m)
    End Sub

    'Beispielcode Sanduhr...
    Public Anhalten As Boolean = False
    Dim Sanduhrthread As Thread

    Private Sub btn_Start_Click(sender As Object, e As EventArgs) Handles btn_Start.Click
        Anhalten = False
        Sanduhrthread = New Thread(AddressOf Sanduhr)
        Sanduhrthread.Start()
    End Sub

    Private Sub btn_Stopp_Click(sender As Object, e As EventArgs) Handles btn_Stopp.Click
        Anhalten = True
    End Sub

    Private Sub Sanduhr()
        If CNC.Send("Remote " & Text, 1) <> "OK" Then MsgBox("Estlcam Steuerungsfenster nicht geöffnet") : Exit Sub 'Verbindung zum Controller herstellen
        CNC.Send("Dir d:\sanduhr")      'Ordner in dem die CNC-Programme für die einzelnen Zahlen gespeichert sind
        CNC.Send("Start at first coordinate") 'Anweisung die CNC-Programme von der aktuellen Position aus direkt zu starten ohne den Nullpunkt zu berücksichtigen.
        CNC.Send("F3000")               'Vorschubgeschwindigkeit setzen...

        Do While Anhalten = False
            CNC.Send("AX70 AY185") 'Hinter das Brett fahren
            CNC.Send("AZ-85") 'Runter fahren
            CNC.Send("AY150") 'Unter das Brett fahren
            CNC.Send("AY135 AZ-20") 'Brett kippen
            CNC.Send("AY150 AZ-85") 'Brett wieder absetzen
            CNC.Send("AY185") 'Hinter das Brett fahren
            CNC.Send("AZ0") 'Hoch auf Nullebene

            Dim X_Pos As Double = 15 'X-Position der 1. Nummer.
            Dim Zeit As String = Now.ToShortTimeString.Replace(":", "#") 'Zeitstring ":" durch "#" ersetzen, da ":" nicht in Dateinamen enthalten sein darf
            For i As Int32 = 0 To Zeit.Length - 1 'Zeitstring Nummer für Nummer durchgehen
                CNC.Send("Load " & Zeit(i) & ".nc") 'CNC Programm der Nummer laden aber noch nicht ausführen...
                CNC.Send("AX" & X_Pos + CNC.Send("Prog X1?") & " AY" & CNC.Send("Prog Y1?")) 'Startposition der Nummer anfahren...
                CNC.Send("Run") 'CNC Programm der Nummer ausführen...
                X_Pos += CNC.Send("Prog DX?") + 15 'X-Position um Breite der Nummer + 15mm erhöhen...
            Next

            CNC.Send("AX70 AY185") 'In Ruheposition fahren...
            Do While Zeit = Now.ToShortTimeString.Replace(":", "#") AndAlso Anhalten = False 'Warten bis die Minute vorbei ist...
                Application.DoEvents()
                Thread.Sleep(500)
            Loop
        Loop
    End Sub

End Class

'Grundfunktionen zur Kommunikation mit dem CNC-Controller...
Public Class CNC_Remote
    Private Str(0 To 1000) As Byte
    Private Str_Index As Int32 = 0
    Private Answer As String = ""
    Private Answer_Received As Boolean = False

    Public Sub Receive(m As Message)
        If m.LParam <> 0 Then
            Str(Str_Index) = m.LParam
            Str_Index += 1
        Else
            Answer = Encoding.UTF8.GetString(Str, 0, Str_Index)
            Str_Index = 0
            Answer_Received = True
        End If
    End Sub

    Public Function Send(ByVal s As String, Optional timeout As Double = Double.MaxValue) As String
        Answer = ""
        Answer_Received = False
        Dim hwnd As IntPtr = FindWindow(vbNullString, "CNC Steuerung")
        Dim b() As Byte = Encoding.UTF8.GetBytes(s & Chr(0))
        For i As Int32 = 0 To b.Length - 1 : PostMessage(hwnd, &H400, 0, b(i)) : Next
        Dim zeit As Double = Now.ToOADate
        Do While Answer_Received = False
            Application.DoEvents()
            Thread.Sleep(5)
            If Now.ToOADate - zeit > timeout / 86400 Then Return "Timeout"
        Loop
        Return Answer
    End Function

    <DllImport("user32.dll", CharSet:=CharSet.Auto, SetLastError:=True)>
    Private Shared Function FindWindow(ByVal lpClassName As String, ByVal lpWindowName As String) As IntPtr
    End Function

    <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Private Shared Function PostMessage(ByVal hWnd As IntPtr, ByVal Msg As UInteger, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As Boolean
    End Function

End Class